﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.ServiceModel.Discovery;
using System.Xml;
using System.ServiceModel.Description;

namespace ServiceLocatorService
{
    [ServiceBehavior(ConcurrencyMode=ConcurrencyMode.Multiple,InstanceContextMode=InstanceContextMode.Single,IncludeExceptionDetailInFaults=true)]
    public class LocatorService :AnnouncementService, IServiceLocator
    {
        private System.Collections.Concurrent.ConcurrentDictionary<XmlQualifiedName, EndpointDiscoveryMetadata> _services= new System.Collections.Concurrent.ConcurrentDictionary<XmlQualifiedName,EndpointDiscoveryMetadata>();
        public LocatorService()
        {
            this.OnlineAnnouncementReceived += new EventHandler<AnnouncementEventArgs>(anService_OnlineAnnouncementReceived);
            this.OfflineAnnouncementReceived += new EventHandler<AnnouncementEventArgs>(anService_OfflineAnnouncementReceived);
        }

        void anService_OfflineAnnouncementReceived(object sender, AnnouncementEventArgs e)
        {
            EndpointDiscoveryMetadata ed;
            _services.TryRemove(e.EndpointDiscoveryMetadata.ContractTypeNames[0], out ed);
        }

        void anService_OnlineAnnouncementReceived(object sender, AnnouncementEventArgs e)
        {
            // Note this will be called for every endpoint and every endpoint will have 1 contract, a service has more contracts
            if (!_services.ContainsKey(e.EndpointDiscoveryMetadata.ContractTypeNames[0]))
            {
                _services[e.EndpointDiscoveryMetadata.ContractTypeNames[0]]= e.EndpointDiscoveryMetadata;
            }
        }

        public string GetAddress(XmlQualifiedName contractname)
        {
            string address = null;
            EndpointDiscoveryMetadata meta=_services[contractname];
            if (meta!=null)
	        {
		        address= meta.Address.ToString();
	        }
            return address;
        }
    }
}
